// 5 ϥ
// move.c  
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// إåեɤ߹
#include "game.h"
#include "board.h"
#include "move.h"
#include "rule.h"

// λɽǡ
const Move resign = { -1, -1, -1, -1, 0};

// λӱۤνλȽؿ
inline bool resigned(Point p) 
    { return (p.x<0)&&(p.y<0); }

inline bool ended(Point p) 
    { return (p.x==0)&&(p.y==0); }

inline bool valid(int v)
    { return (v>0 && v<MAXBOARD); }

inline bool isresign(Move m)
    { return resigned(m.from) && resigned(m.to); }

// Ϥ줿ɸx,yʬ
//     *s: ʸ
//   true, (p->x,p->y)˷
bool separate(char *s, Point *p) {
    char *s2 = s;
    switch (*s2) {
      case 'q': p->x=p->y = -1; return true; // λ
      case 'e': p->x=p->y =  0; return true; // ӱۤλ
      default:
            while (*s2 && *s2 != ' ') s2++;  // θ
            if (*s2 == 0) return false;
            *s2= 0; s2++;
            p->x = atoi(s);
            p->y = atoi(s2);
            return valid(p->x)&&valid(p->y); // ϰϳʤ饨顼
      }
}

// ɸ
//    *mes:å
//  (p->x,p->y)Ϸ
void input_point(const char *mes, Point *p) 
{
    char buf[80];
    int x,y;
    while (1) {
       printf(mes);
       fgets(buf,80,stdin); 		// buf
       if (strchr(buf,'\n')==0) 	// Ԥޤޤʤʤ
           while (fgetc(stdin)!='\n') ; // ԤޤǶɤ
       if (separate(buf,p)) return;	// ʬΥ
       printf("error:input format\n");
    }
}

// (ӱۤޤޤʤ)1ʬ
void input_move_one(Move *mp,const Board *bp)
{ 
    while (1) {
        // 
        input_point("from:",&(mp->from));
        if (resigned(mp->from)) { *mp = resign; break; }
        // 
        input_point("to  :",&(mp->to));
        if (resigned(mp->to))   { *mp = resign;  break; }
        // 롼븡
        if (check_rules(mp,bp)) break;
        printf("error:illegal move\n");
    }
    mp->next = 0;
}

// ӱۤޤ
void input_move(Move *mp,const Board *bp) {
    int c=0; // 줿Фο
    extern const char *turnname[];

    printf("%s's turn\n", turnname[bp->turn]);

    // 1
    input_move_one(mp,bp);
    if (resigned(mp->from)) return;

    // ФꡢӱۤǤ¤귫֤
    while (++c < bp->white_leave && isjump(mp->from,mp->to)) {
        Move *mp2 = (Move*)malloc(sizeof(Move));
        mp2->from = mp->to; mp2->next = 0;
        while (1) {
            input_point("to  :", &(mp2->to));
            if (ended(mp2->to)) return;
            if (isjump(mp2->from,mp2->to)&&
                getcolor(bp,mp2->to)==c_empty) break;
            printf("error:illegal move\n");
        }
        mp->next = mp2; mp=mp2;
    }
}

// ɽ
//  *mp: ꥹȤƬ
void show_move(const Move *mp) {
    printf("move:(%d,%d)", mp->from.x, mp->from.y);
    for (;mp;mp=mp->next) {
        printf("->(%d,%d)",mp->to.x, mp->to.y);
    }
    printf("\n");
}

// 1ϤΥƥ
void test_input_move_one()
{
    Move m;
    Board b;
    init_board(&b);
    show_board(&b);

    input_move_one(&m,&b);
    printf("move:(%d,%d)->(%d,%d)\n", 
        m.from.x, m.from.y, m.to.x, m.to.y);
    update_board(&m,&b);
    show_board(&b);
}

// ̹
//   *mp: 
//   *bp ȹ
void update_board(const Move *mp, Board *bp)
{
   for (;mp;mp=mp->next) {

       Color c = getcolor(bp, mp->from);

       setcolor(bp,mp->from,c_empty);
       setcolor(bp,mp->to,  c);

       if (c == c_black) { bp->black_pos = mp->to; }
       if (isjump(mp->from, mp->to)) {
         Point p = inter(mp->from,mp->to);
         if (getcolor(bp,p) == c_white) {
             setcolor(bp,p, c_empty);
             bp->white_leave--;
         }
      }
   }
}

// ɸϤΥƥ
void test_input_point() 
{
    Point from, to;
    input_point("from:",&from);
    input_point("to  :",&to  );
    printf("(%d,%d)->(%d,%d)\n", from.x, from.y, to.x, to.y);
}

// ̾
const char* dirname[] = 
    { "none", "up", "down", "left", "right", 0 };

// ФΥƥ
void test_getdir()
{
    Point from, to;
    input_point("from:", &from);
    input_point("to  :", &to  );
    printf("dir=%s\n", dirname[getdir(from,to)]);
}

// ̹ƥȥǡ
const Move m1 = { {4,4}, {5,4}, 0} ;
const Move m2 = { {3,3}, {3,4}, 0} ;
const Move m3 = { {5,4}, {5,5}, 0} ;
const Move m4 = { {5,3}, {5,4}, 0} ;
const Move m6 = { {5,3}, {3,3}, 0} ;
const Move m5 = { {5,5}, {5,3}, &m6} ;

// ̹Υƥ
void test_update_board() 
{
    Board b;
    init_board(&b);	  // 
    show_board(&b);

    update_board(&m1,&b); // 
    show_board(&b);

    update_board(&m2,&b); // 
    show_board(&b);

    update_board(&m3,&b); // 
    show_board(&b);

    update_board(&m4,&b); // 
    show_board(&b);

    update_board(&m5,&b); // 
    show_board(&b);
}
